<?php
namespace Modules\Cadastros\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification;
use Modules\Cadastros\Services\gql02200AvisoQualificacaoFonercedorService;
use Zeedhi\Framework\DTO\Response\Message;

class gql02200AvisoQualificacaoFonercedorController extends \Zeedhi\Framework\Controller\Report{
const TIPO = array
    (
        "Fornecedor" => "F",
        "Cliente"    => "C",
        "Prospect"   => "P",
        "Fabricante" => "B",
    );
    
    protected $service;
    protected $connection;
    protected $qr2Strategy;
    
    
    
    public function __construct 
    (
        reportService $reportService,
        gql02200AvisoQualificacaoFonercedorService $service,
        $connection,
        $qr2Strategy
    ) {
        parent::__construct($reportService);
        $this->service       = $service;
        $this->connection    = $connection;
        $this->qr2Strategy   = $qr2Strategy;
    }
    
    public function insertAvisoQualificacao(DTO\Request $request, DTO\Response $response) {
		try {
            $row = $request->getRow(); 
            $codrisco = $this->service->getCdAviso($row);
            if ($codrisco) {
            	throw new \Exception("CodAvisoQualiCadastrado");
            }
            $nmrisco = $this->service->getAviso($row);
            if ($nmrisco) {
            	throw new \Exception("AvisoQualiCadastrado");	
            }
            
            if ((empty($codrisco)) and (empty($nmrisco))) {
    			$this->service->insertAvisoQualificacao($row);
            }
            
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
	
	public function updateAvisoQualificacao(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow(); 

            
			$this->service->updateAvisoQualificacao($row);
			
		} 
		catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
    }

    
    public function deleteAvisoQualificacao(DTO\Request $request, DTO\Response $response) {
		try {
            $row = $request->getRow();
			$this->service->deleteAvisoQualificacao($row);
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
	
};
