<?php

namespace Modules\Cadastros\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class gql00400TipoDeRiscoService
{
    protected $connection;
    
    public function __construct($entityManager, $environment)
    {
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
    }
    
    /* ****************
     *    SELECT      *
     ******************/
    
    public function getCodRisco($row) 
    {
		$param = array(
		    'P_CDTIPRISCO' => $row['P_CDTIPRISCO']
		);
		
        $query = "SELECT
                     CDTIPRISCO
                 FROM
                     TIPORISCO
                 WHERE
                     (CDTIPRISCO = :P_CDTIPRISCO)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function getOcorrencia($row) 
    {
		$param = array(
		    'P_CDTIPRISCO' => $row['P_CDTIPRISCO']
		);
		
        $query = "SELECT
                     CDTIPRISCO
                 FROM
                     OCORRENCIA
                 WHERE
                     (CDTIPRISCO = :P_CDTIPRISCO)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function getToleconf($row) 
    {
		$param = array(
		    'P_CDTIPRISCO' => $row['P_CDTIPRISCO']
		);
		
        $query = "SELECT
                     CDTIPRISCO
                 FROM
                     TOLECONF
                 WHERE
                     (CDTIPRISCO = :P_CDTIPRISCO)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function getNmRisco($row) 
    {
		$param = array (
		    'P_NMTIPORISCO' => $row['P_NMTIPORISCO']
		); 

        $query = "SELECT
                     NMTIPORISCO
                 FROM
                     TIPORISCO
                 WHERE
                     (NMTIPORISCO = :P_NMTIPORISCO)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    /* ***************
     *    INSERT     *
     *****************/
    
    public function insertTipoRisco($row) 
    {
		$param = array(
		    'P_CDTIPRISCO'  => $row['P_CDTIPRISCO'],
		    'P_NMTIPORISCO' => $row['P_NMTIPORISCO']
		);
		
        $query = "INSERT INTO TIPORISCO
                     (CDTIPRISCO, NMTIPORISCO)
                 VALUES
                     (:P_CDTIPRISCO, :P_NMTIPORISCO)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    /* ****************
     *    UPDATE      *
     ******************/
    
    public function updateTipoRisco($row) 
    {
		$param = array(
		    'P_CDTIPRISCO'  => $row['P_CDTIPRISCO'],
		    'P_NMTIPORISCO' => $row['P_NMTIPORISCO']
		);
		
        $query = "UPDATE TIPORISCO
                     SET CDTIPRISCO  = :P_CDTIPRISCO,
                         NMTIPORISCO = :P_NMTIPORISCO
                   WHERE CDTIPRISCO  = :P_CDTIPRISCO";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    /* ****************
     *    DELETE      *
     ******************/
    
    public function deleteTpRisco($row) 
    {
		$param = array(
		    'P_CDTIPRISCO'  => $row['P_CDTIPRISCO']
		);
		
        $query = "DELETE FROM TIPORISCO
                   WHERE CDTIPRISCO = :P_CDTIPRISCO";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e) {
            throw $e;
        }
    }
}