<?php
namespace Indeterminado\Repositories;

class Usuprecoprop extends \Doctrine\ORM\EntityRepository
{
    public static function getQtdFinUsuarios($cdPreco)
    {
        $sql = "SELECT MAX(QTFINUSUARIOS) AS MAXUSU
                  FROM USUPRECOPROP
                 WHERE CDPRECOPROP = :CDPRECOPROP";
        
        $params = array("CDPRECOPROP" => $cdPreco);

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public static function getDescUsuariosAte($cdPreco, $qtUsuarios)
    {
        $sql = "SELECT VRPERCDESCUSU, QTFINUSUARIOS, QTINIUSUARIOS
                  FROM USUPRECOPROP
                 WHERE CDPRECOPROP = :CDPRECOPROP
                   AND :QTDE_USUARIOS > QTFINUSUARIOS";
        
        $params = array("CDPRECOPROP"   => $cdPreco,
                        "QTDE_USUARIOS" => $qtUsuarios);

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public static function getDescUsuarios($cdPreco, $qtUsuarios)
    {
        $sql = "SELECT QTINIUSUARIOS, QTFINUSUARIOS, VRPERCDESCUSU
                  FROM USUPRECOPROP
                 WHERE CDPRECOPROP = :CDPRECOPROP
                   AND :QTDE_USUARIOS BETWEEN QTINIUSUARIOS AND QTFINUSUARIOS
                 ORDER BY 1";
        
        $params = array("CDPRECOPROP"   => $cdPreco,
                        "QTDE_USUARIOS" => $qtUsuarios);

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
}