<?php

/**
 * Gpevinculom
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     SetForms Team <development@setforms.com>
 * @version    SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class Gpevinculom extends DaoGpeVinculom
{
    protected static $historico_link = 'NRVINCULOM';
    protected static $historico_class = 'Gpevinculoh';


    public static function getVinculo($nrorg, $nrvinculom) {
        return self::getObjectByWhere('NRORG = ? AND NRVINCULOM = ?', array($nrorg, $nrvinculom));
    }

    /**
     * Prepara consulta SQL.
     *
     * @param integer    $nrOrg          Numero da Organizacao.
     * @param TkDateTime $mesCompetencia Mes de competencia.
     * @param string     $primeiroDiaAno Data - primeiro dia do ano do mes de competencia.
     * @param string     $condProcesso   Clausula where com as condicoes de processo.
     * @param string     $condIntervalo  Clausula where com as condicoes de intervalo.
     * @param string     $ordenacao      Clausula de ordenacao.
     *
     * @return string
     *
     * @author alessandrobartels - 21/12/2011
     * @todo refatorar este método e seu uso
     */
    private static function _montaSQLVinculo(
        $nrOrg, TkDateTime $mesCompetencia, $primeiroDiaAno, $condProcesso, $condIntervalo, $ordenacao, $condEstrutura,
        $verificaConfidencial = true, $nrTipoVinculom = null, $nrVinculoEmpreg = null, $nrEstrutSind = null
    ){

        $processo = false;
        $intervalo = false;
        $estrutura = false;
        $confidencial = '';

        $dtUltDiaMes = new TkDateTime($mesCompetencia);
        $dtUltDiaMes->setDay(1)->addMonth(1)->subDay(1);
        // LEANDRO - 05/08/2013
        // leonardocarvalho 06/11/2013 - alterado para retornar a quantidade de vinculos ativos na estrutura no mes da competencia
        if(\FPA::getRestConfidencial()==='S' && $verificaConfidencial){
            $confidencial = " AND GPE_VINCULOH.CONFIDENCIAL='N' ";
        }
        $sql = 'SELECT MAXVINCH.DTMESCOMPETENC, GPE_VINCULOM.*
				  FROM GPE_VINCULOM
				  INNER JOIN
                      (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC, NRVINCULOM, NRORG
                         FROM GPE_VINCULOH
                         WHERE DTMESCOMPETENC >= \''.$primeiroDiaAno.'\'
						 AND DTMESCOMPETENC <= \''.$dtUltDiaMes.'\'
                         AND NRORG =  '.$nrOrg.'
                         GROUP BY NRVINCULOM, NRORG
                      ) MAXVINCH
                  ON MAXVINCH.NRVINCULOM = GPE_VINCULOM.NRVINCULOM
                  AND MAXVINCH.NRORG = GPE_VINCULOM.NRORG

                  INNER JOIN GPE_VINCULOH
				  ON GPE_VINCULOH.NRVINCULOM = MAXVINCH.NRVINCULOM
				  AND GPE_VINCULOH.DTMESCOMPETENC = MAXVINCH.DTMESCOMPETENC
				  AND GPE_VINCULOH.NRORG = MAXVINCH.NRORG
                 '.$confidencial.'
                 ';
                 /* INNER JOIN GPE_PESSOAH
                  ON GPE_PESSOAH.NRPESSOA = GPE_VINCULOM.NRPESSOA
                  AND GPE_PESSOAH.NRORG = GPE_VINCULOM.NRORG

                  INNER JOIN
                  	  (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC, NRPESSOA, NRORG
                		FROM GPE_PESSOAH
                		WHERE DTMESCOMPETENC <=  \''.$mesCompetencia.'\'
                		GROUP BY NRPESSOA, NRORG
              		  ) PHATUAL
            	  ON PHATUAL.DTMESCOMPETENC = GPE_PESSOAH.DTMESCOMPETENC
            	  AND PHATUAL.NRPESSOA = GPE_PESSOAH.NRPESSOA
            	  AND PHATUAL.NRORG = GPE_PESSOAH.NRORG*/

        $where = ' WHERE ';

        if (empty($condProcesso) === false) {
            $where .= $condProcesso;
            $processo = true;
        }

        if (empty($condIntervalo) === false) {
            if ($processo === true) {
                $where .= ' AND ';
            }

            $where .= $condIntervalo;
            $intervalo = true;
        }

        if (empty($condEstrutura) === false) {
            if (($processo === true) || ($intervalo === true)) {
                $where .= ' AND ';
            }

            $where .= $condEstrutura;
            $estrutura = true;
        }

        if ($processo === false
            && $intervalo === false
            && $estrutura === false
        ) {
            $where .= ' (1=1) ';
        }

        //PCK 17/03/2015
        //Inclusão do filtro por tipo de vínculo e tipo de vínculo empregatício ($nrTipoVinculom e $nrVinculoEmpreg)
        if($nrTipoVinculom != null) {
            if($where != ' WHERE ')
                $where .= ' AND ';
            $where .= 'GPE_VINCULOM.NRTIPOVINCULOM = '.$nrTipoVinculom;
        }

        if($nrVinculoEmpreg != null) {
            if($where != ' WHERE ')
                $where .= ' AND ';
            $where .= 'GPE_VINCULOM.NRVINCULOEMPREG = '.$nrVinculoEmpreg;
        }

        if($nrEstrutSind != null) {
            if($where != ' WHERE ')
                $where .= ' AND ';
            $where .= 'GPE_VINCULOH.NRESTRUTSIND = '.$nrEstrutSind;
        }

        if (empty($ordenacao) === false) {
            $where .= ' '.$ordenacao;
        }


        $sql .= $where;
//tk_warning($sql);
        return $sql;
    }


    /**
     * Retorna lista de objetos Gpevinculom com historico agregado.
     *
     * @param integer    $nrOrg          Numero da Organizacao.
     * @param TkDateTime $mesCompetencia Mes de Competencia.
     * @param string     $condProcesso   Clausula where com as condicoes de processo.
     * @param string     $condIntervalo  Clausula where com as condicoes de intervalo.
     * @param string     $ordenacao      Clausula de ordenacao.
     *
     * @return array Gpevinculom
     *
     * @author alessandrobartels
     *         alessandrobartels - 14/07/2011 - Modificada consulta. O vinculo agora faz relacionamento direto com a
     *                                          pessoa.
     */
    public static function retornaVinculos(
        $nrOrg, TkDateTime $mesCompetencia, $condProcesso = null, $condIntervalo = null, $ordenacao = null, $condEstrutura = null, $verificaConfidencial = true, $nrTipoVinculom = null, $nrVinculoEmpreg = null, $nrEstrutSind = null){

         // Determina o primeiro dia do ano para otimizar a consulta, visto que existira sempre 1 historico por ano.
        $primeiroDiaAno = new TkDateTime($mesCompetencia);
        $primeiroDiaAno->setDay(1)->setMonth(1);

        $sql = self::_montaSQLVinculo(
            $nrOrg, $mesCompetencia, $primeiroDiaAno, $condProcesso, $condIntervalo, $ordenacao, $condEstrutura, $verificaConfidencial, $nrTipoVinculom, $nrVinculoEmpreg, $nrEstrutSind
        );

        unset($primeiroDiaAno);

        /*    $sql = 'SELECT GPE_PESSOA.NRPESSOA, GPE_PESSOAH.NMPESSOA, GPE_VINCULOM.*, GPE_PESSOAH.DTMESCOMPETENC
    			  FROM GPE_VINCULOM,GPE_PESSOA,GPE_PESSOAH,
    			  (
    					SELECT GP.NRPESSOA, MAX(GP.DTMESCOMPETENC) DTMESCOMPETENC, GP.NRORG
    					FROM GPE_PESSOAH GP
    					WHERE GP.DTMESCOMPETENC <= \''.$mes_competencia.'\'
    					AND GP.NRORG = '.$nrorg.'
    					GROUP BY GP.NRPESSOA, GP.NRORG
    			  ) GP
    			  WHERE GPE_VINCULOM.NRPESSOA = GPE_PESSOA.NRPESSOA
    			  AND GPE_PESSOA.NRORG = GPE_PESSOAH.NRORG
    			  AND GPE_VINCULOM.NRORG = GPE_PESSOA.NRORG
    			  AND GP.NRORG = GPE_VINCULOM.NRORG
    			  AND GPE_PESSOA.NRPESSOA = GPE_PESSOAH.NRPESSOA
    			  AND GP.NRPESSOA = GPE_PESSOAH.NRPESSOA
    			  AND GP.DTMESCOMPETENC = GPE_PESSOAH.DTMESCOMPETENC
    			  AND GPE_VINCULOM.DTADMISSAOVINC <= \''.$mes_competencia.'\'
    			  AND GPE_PESSOAH.DTMESCOMPETENC <= \''.$mes_competencia.'\'
    			  AND UPPER(GPE_PESSOAH.NMPESSOA) BETWEEN \''.$ds_inicio.'\' AND \''.$ds_fim.'\'';
        */

        return self::_retornaVinculos($nrOrg, $sql, $mesCompetencia);
    }

    /**
     * Retorna lista de objetos GpevinculomEntity com GpevinculohEntity agregado.
     *
     * @param integer    $nrorg          Numero da Organizacao.
     * @param string     $sql            Parametro de SQL.
     * @param TkDateTime $mesCompetencia Data de competencia.
     *
     * @return array GpevinculomEntity
     *
     * @author alessandrobartels
     *         alessandrobartels - 26/08/2011 - retorna o historico autal a uma data de competencia.
     *         									Tramitado metodo retornaUltimoHistorico para Gpevinculoh.
     *         									Passa a se chamar retornaHistoricoAtual
     */
    public static function _retornaVinculos($nrorg, $sql, TkDateTime $mesCompetencia){

        /* $db = TkDb::singleton(); */
        $db = \Setforms2\Runtime\Connection::getInstance();
        $resultado = $db->fetchAll($sql);

        $vinculos = self::createObjectsFromArray($resultado);
        foreach ($vinculos as $vinculo) {
            $dao = $vinculo->getDao();

            /* $historico = self::retornaUltimoHistorico($nrorg, $dao->NRVINCULOM); */
            // BORBA 19/03/2013 Metodo end() a principio deve ser mantido, mesmo que seja retornado somente um historico o createObjectsFromArray cria um array de objetos;
            $historico = end(Gpevinculoh::retornaHistoricoAtual($nrorg, $dao->NRVINCULOM, $mesCompetencia));
            $vinculo->historico = $historico;
        }

        return $vinculos;
    }


    /**
     * Retorna lista de objetos Gpevinculoh.
     *
     * @param integer $nrorg   Numero da Organizacao.
     * @param integer $vr_link Numero do vinculo.
     *
     * @return Gpevinculoh
     *
     * @author alessandrobartels
     */
    /*
    public static function retornaUltimoHistorico($nrorg, $vr_link){
        $class = self::$historico_class;
        $vinculos_historico = $class::getObjectsByWhere(
            'NRORG = ? AND
		     NRVINCULOM = ? ',
            array(
             $nrorg, $vr_link,
            ),
            'DTMESCOMPETENC'
        );

        $vh = end($vinculos_historico);
        return $vh;
    }
    */


    /**
     * Retorna o Objeto VinculoM.
     *
     * @param integer $nrvinculom Nr Vinculo.
     * @param integer $nrorg      Nr org.
     *
     * @return GpevinculomEntity
     *
     * @author luistavares - 12/08/2011
     */
    public static function retornaVinculo($nrvinculom, $nrorg){
        $vinculom = self::getObjectByWhere(
            'NRORG = ?
             AND NRVINCULOM = ?',
            array(
             $nrorg, $nrvinculom,
            )
        );
        return $vinculom;
    }


    /**
     * Retorna array de instancias de vinculo mestre por matricula.
     *
     * @param integer $nrOrg     Numero da Organizacao de trabalho.
     * @param string  $matricula Matricula.
     * @param string  $estrutura Estrutura.
     *
     * @return array GpevinculomEntity
     *
     * @author talitaorfano 06/09/2011
     *         thalesvalias 26/11/2012 - Estrutura passa a ser considerada.
     */
    public static function retornaVinculoPorMatriculaEstrutura($nrOrg, $matricula, $estrutura){

//        $vinculo = self::getObjectByWhere(
//            'NRORG = ? AND CDMATRICULA = ?',
//            array(
//             $nrOrg, $matricula,
//            )
//        );

        $sql = "SELECT VM.*, VH.DTMESCOMPETENC
                    FROM GPE_VINCULOM VM
                    INNER JOIN GPE_VINCULOH VH ON
                    (VM.NRVINCULOM = VH.NRVINCULOM AND VM.NRORG = VH.NRORG)
                    WHERE VM.NRORG = $nrOrg
                    AND VM.CDMATRICULA = '$matricula'
                    AND VH.NRESTRUTLEGAL = $estrutura
                    ORDER BY VH.DTMESCOMPETENC";
        $resultado = \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);

        $vinculo = self::createObjectsFromArray($resultado);

        return $vinculo;
    }


    /**
     * Retorna array de instancias de vinculo mestre por Pessoa.
     *
     * @param integer $nrOrg    Numero da Organizacao de trabalho.
     * @param integer $nrPessoa Numero da Pessoa.
     *
     * @return array GpevinculomEntity
     *
     * @author talitaorfano 06/09/2011
     */
    public static function retornaVinculosPorPessoa($nrOrg, $nrPessoa){
        $vinculos = self::getObjectsByWhere(
            'NRORG = ? AND NRPESSOA = ?',
            array(
             $nrOrg, $nrPessoa,
            )
        );
        return $vinculos;
    }


    /**
     * Retorna array de instancias de vicnculo mestre.
     *
     * @param integer $nrOrg Numero do Organizacao de trabalho.
     *
     * @return array GpevinculomEntity
     *
     * @author alessandrobartels - 20/10/2011
     */
    public static function retornaVinculoMestre($nrOrg){
        $vinculom = self::getObjectsByWhere(
            'NRORG = ?',
            array($nrOrg),
            'NRVINCULOM'
        );
        return $vinculom;
    }

    public static function getTomador($nrorg, $nrestrutgeren) {
        $sql = "SELECT TOMADOR_POR_GERENCIAL($nrorg, $nrestrutgeren) TOMADOR FROM DUAL";
        $resultado = \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);
        return isset($resultado) ? $resultado[0]["TOMADOR"] : null;
    }

}