<?php
/**
 * Created by JetBrains PhpStorm.
 * User: alessandrobartel
 * Date: 16/04/12
 * Time: 17:57
 * To change this template use File | Settings | File Templates.
 */
 
class Estruturacao {

    // @todo constante de endereco deve ficar na EnderecoparcEntity e nao aqui.
    const ENDERECO_PRINCIPAL = 'PRINCIPAL';
    const FORMA_COMUNICACAO_TEL_PRINCIPAL = '01';
    const FORMA_COMUNICACAO_EMAIL = '05';

    private $_nrOrg;
    private $_nrOrgPadrao;
    private $_mesCompetencia;
    private $_ultimoDiaCompetencia;
    private $_dtAux;

    private $_estrutura;
    private $_estruturaTomador;
    private $_hierarquiaOrg;
    private $_hierarquiaOrgTomador;
    private $_tipoHierarquia;
    private $_tipoHierarquiaTomador;
    private $_movimentacao;
    private $_movimentacaoVinculoResponsavel;
    private $_movimentacoesVinculoTomador;

    private $_areaRisco;
    private $_vinculoAreaRisco;
    private $_estruturaAreaRisco;

    private $_enderecoParc;
    private $_comunicaParc;
    private $_municipio;
    private $_bairro;
    private $_listaDDD = array(
        "SP" => '011',
        "RJ" => '022',
        "ES" => '027',
        "MG" => '031',
        "PR" => '041',
        "SC" => '048',
        "RS" => '051',
        "DF" => '061',
        "GO" => '062',
        "TO" => '063',
        "MT" => '065',
        "MS" => '067',
        "AC" => '068',
        "RO" => '069',
        "BA" => '071',
        "SE" => '079',
        "PE" => '081',
        "AL" => '082',
        "PB" => '083',
        "RN" => '084',
        "CE" => '085',
        "PI" => '086',
        "PA" => '091',
        "AM" => '092',
        "RR" => '095',
        "AP" => '096',
        "MA" => '098',
    );

    public function __construct($nrOrg, $nrOrgPadrao, $mesCompetencia){

        $this->_nrOrg = $nrOrg;
        $this->_nrOrgPadrao = $nrOrgPadrao;
        $this->_mesCompetencia = $mesCompetencia;
        $this->_ultimoDiaCompetencia = new TkDateTime($this->_mesCompetencia);
        $this->_ultimoDiaCompetencia->addMonth(1)->subDay(1);
        $this->_dtAux = new TkDateTime();

        $this->_estrutura = new EstruturamEntity(null, $this->_nrOrg, $this->_mesCompetencia);
        $this->_estruturaTomador = new EstruturamEntity(null, $this->_nrOrg, $this->_mesCompetencia);
        $this->_hierarquiaOrg = new HierarquiaorgEntity();
        $this->_hierarquiaOrgTomador = new HierarquiaorgEntity();
        $this->_tipoHierarquia = new TipohierarqorgEntity();
        $this->_tipoHierarquiaTomador = new TipohierarqorgEntity();
        $this->_movimentacao = new GpemovimentacaoEntity();

        $this->_areaRisco = new SstAreariscomEntity();
        $this->_vinculoAreaRisco = new SstVincareariscoEntity();
        $this->_estruturaAreaRisco = new SstEstrutareariscoEntity();

        $this->_enderecoParc = new EnderecoparcEntity();
        $this->_municipio = new MunicipioEntity();
        $this->_bairro = new BairroEntity();
        $this->_comunicaParc = new ComunicaparcEntity();
    }


    public function getAreaRisco(){
        return $this->_areaRisco;
    }


    public function carregaHierarquias($nrTpHierarquiaOrg){
        $this->_hierarquiaOrg->carregaHierarquiasPorTipo($this->_nrOrg, $nrTpHierarquiaOrg);
    }

    
    public function carregaHierarquiasTomador($nrTpHierarquiaOrgTomador){
        $this->_hierarquiaOrgTomador->carregaHierarquiasPorTipo($this->_nrOrg, $nrTpHierarquiaOrgTomador);
    }


    public function carregaTipoHierarquia($nrTpHierarquiaOrg){
        $this->_tipoHierarquia->carregaTipoHierarquia($this->_nrOrgPadrao, $this->_nrOrg, $nrTpHierarquiaOrg);
    }


    public function carregaTipoHierarquiaTomador($nrTpHierarquiaOrgTomador){
        $this->_tipoHierarquiaTomador->carregaTipoHierarquia($this->_nrOrgPadrao, $this->_nrOrg, $nrTpHierarquiaOrgTomador);
    }


    public function getMovimentacaoVinculoResponsavel(){
        return $this->_movimentacaoVinculoResponsavel;
    }

    
    public function getMovimentacaoVinculoTomador($posicao){
        return $this->_movimentacoesVinculoTomador[$posicao];
    }

    public function retornaEstrutura($nrEstrutura) {
        return $this->_estrutura->retornaEstrutura($nrEstrutura);
    }


    private function _verificaPeriodoValidoMes($data){
        $this->_dtAux->set($this->_mesCompetencia);
        $this->_dtAux->addMonth(1)->subDay(1);
        $dtInicio = $this->_mesCompetencia->toString(TkDateTime::FORMAT_DATE);
        $dtFim = $this->_dtAux->toString(TkDateTime::FORMAT_DATE);

        if (empty($data) === false) {
            $existe = $this->_verificaDataPeriodo($data, $dtInicio, $dtFim);
        } else {
            $existe = true;
        }

        return $existe;
    }

    
    // @todo - Verificar se este metodo deve ficar nesta classe
    //(DTFIMMOVIMENT BETWEEN ? AND ?  OR DTFIMMOVIMENT IS NULL)
    private function _verificaDataPeriodo($data, $dtInicio, $dtFim){
        $this->_dtAux->set($data);
        if ($this->_dtAux->isLater($dtInicio) || $this->_dtAux->equals($dtInicio)
           && $this->_dtAux->isEarlier($dtFim) || $this->_dtAux->equals($dtFim) ) {
            return true;
        } else {
            return false;
        }

    }


    public function incluiMovimentacaoVinculo(
        $nrTipoTransf, $nrVinculo, $nrEstrutura, $dtIniMoviment, $nrTipoEstrutura, $nrTpMovTransf, $dtRetroativa,
        $idAtualizacao, $dtFimMovimento
    ){
        $mov = $this->_movimentacao->incluiMovimentacao(
            $this->_nrOrg, $nrTipoTransf, $nrVinculo, $nrEstrutura, $dtIniMoviment, $nrTipoEstrutura, $nrTpMovTransf, $dtRetroativa,
            $idAtualizacao, $dtFimMovimento
        );

        return $mov;
    }


    public function verificaExistenciaMovimentacao($nrTpMovTransferencia, $dtIniMovimento, $dtRetroativa){
        $verificaMovimentacao = $this->_movimentacao->verificaMovPorTipoTransferencia(
            $nrTpMovTransferencia, $dtIniMovimento, $dtRetroativa
        );

        return $verificaMovimentacao;
    }


    public function getMovimentacoesVinculo($nrVinculo){
        $this->_movimentacao->carregaMovimentacoes($this->_nrOrg, $nrVinculo, $this->_ultimoDiaCompetencia);

        return $this->_movimentacao->getItems();
    }


    // CAGED / Homolognet
    public function getMovimentacoesVinculoPorTipo($nrVinculo, $tipo){
        $tipoEstrutura = \FPA::getTipoEstruturaLegalOrg();
        $this->_movimentacao->carregaMovimentacoesPorTipo(
            $this->_nrOrg, $nrVinculo, $tipo, $this->_ultimoDiaCompetencia, $tipoEstrutura
        );

        return $this->_movimentacao->getItems();
    }


    /**
     * CNAB.
     * retorna a movimentacao corrente do vinculo informado, de acordo com o tipo.
     *
     * @param integer $nrVinculo Numero do Vinculo.
     * @param integer $tipo      Tipo da Movimentacao (Legal, Gerencial).
     *
     * @return instancia de GpemovimentacaoEntity
     */
    public function getMovimentacaoVinculoPorTipo($nrVinculo, $tipo){
        $tipoEstrutura = \FPA::getTipoEstruturaLegalOrg();
        $this->_movimentacao->carregaMovimentacoesPorTipo(
            $this->_nrOrg, $nrVinculo, $tipo, $this->_ultimoDiaCompetencia, $tipoEstrutura
        );

        return current($this->_movimentacao->getItems());
    }


    /* homolognet.
     * retorna a movimentacao corrente do vinculo informado, de acordo com a hierarquia.
     * @param integer $nrVinculo Numero do Vinculo.
     * @param integer $nrHierarquia      Número da hierarquia.
     * @return instancia de GpemovimentacaoEntity
     */
    public function getEstruturas($nrVinculom, $nrTipoHierarquia){

        $paramsTipoHierarquia = array($this->_nrOrgPadrao, $this->_nrOrg, $nrTipoHierarquia);
        /** @var $tipoHierarquia TipohierarqorgEntity */
        $tipoHierarquia = TipohierarqorgEntity::getEntityByWhere(
            '(NRORG = ? OR NRORG = ?) AND NRTIPOHIERARQORG = ?', $paramsTipoHierarquia
        );

        $this->_movimentacao->carregaMovimentacoesPorHierarquia($this->_nrOrg, $nrVinculom,
            $tipoHierarquia->getNrtipoestrutrel(), $this->_mesCompetencia, $this->_ultimoDiaCompetencia);

        /** @var $item GpemovimentacaoEntity */
        foreach($this->_movimentacao->getItems() as $item){
            $this->_estrutura->carregaEstrutura($item->getNrestruturam());
            /** @var $estrutura EstruturamEntity */
            $estrutura = $this->_estrutura->getEstrutura();
            if($estrutura){
                return $estrutura;
            }
        }
        return null;

    }

    public function getEstruturaSuperior($movimentacao){

        $hierarquias = $this->_hierarquiaOrg->getItems();
        $tpHierarquia = $this->_tipoHierarquia->getItem(0);

        if ((int)$movimentacao->getNrtipoestrutura() === (int)$tpHierarquia->getNrtipoestrutrel()) {
            $nrEstruturaSup = $this->_determinaEstruturaSuperior(
                $hierarquias, $movimentacao->getNrestruturam(), $tpHierarquia->getIdautohierarq()
            );

            $this->_estrutura->carregaEstrutura($nrEstruturaSup);
            $estrutura = $this->_estrutura->getEstrutura();

            return $estrutura;
         //   $this->_movimentacaoVinculoResponsavel = $item;

        }

    }

        // Homolognet
    public function getEstruturaSuperiorTomador($movimentacao){

        $hierarquiasTomador = $this->_hierarquiaOrgTomador->getItems();
        $tpHierarquiaTomador = $this->_tipoHierarquiaTomador->getItem(0);
        if ((int)$movimentacao->getNrtipoestrutura() === (int)$tpHierarquiaTomador->getNrtipoestrutrel()) {
            $nrEstruturaSup = $this->_determinaEstruturaSuperior(
                $hierarquiasTomador, $movimentacao->getNrestruturam(), $tpHierarquiaTomador->getIdautohierarq()
            );

            $this->_estruturaTomador->carregaEstrutura($nrEstruturaSup);
            return $this->_estruturaTomador->getEstrutura();
         //   $this->_movimentacaoVinculoResponsavel = $item;

        }

    }


    // SEFIP
    public function retornaEstruturaResponsavel($nrVinculo, $dtInicio, $dtFim){

        $hierarquias = $this->_hierarquiaOrg->getItems();
        $tpHierarquia = $this->_tipoHierarquia->getItem(0);

        //@todo Carregar todas as movimentacoes e testar dentro do foreach se a movimentacao esta na data corrente.
        $this->_movimentacao->carregaMovimentacoesPeriodo($this->_nrOrg, $nrVinculo, $dtInicio, $dtFim);

        foreach($this->_movimentacao->getItems() as $item){
            //@todo  - filtrar as movimentacoes por tipo de transferencia (legal / gerencial)
            if ((int)$item->getNrtipoestrutura() === (int)$tpHierarquia->getNrtipoestrutrel()) {
                 $nrEstruturaSup = $this->_determinaEstruturaSuperior(
                    $hierarquias, $item->getNrestruturam(), $tpHierarquia->getIdautohierarq()
                );
                $this->_estrutura->carregaEstrutura($nrEstruturaSup);
                $this->_movimentacaoVinculoResponsavel = $item;

            }
        }

        return $this->_estrutura->getItem(0);
    }


    // Utilizado para o SEFIP
    public function retornaEstruturaTomador($nrVinculo, $dtInicio, $dtFim){
        $this->_estruturaTomador->resetItems();
        $this->_movimentacoesVinculoTomador = array();

        $hierarquiasTomador = $this->_hierarquiaOrgTomador->getItems();
        $tpHierarquiaTomador = $this->_tipoHierarquiaTomador->getItem(0);

        //@todo Carregar todas as movimentacoes e testar dentro do foreach se a movimentacao esta na data corrente.
        // nao esta carregando por tipo, assim a carga para responsavel já valeu - rigel 26/03/2013
        //$this->_movimentacao->carregaMovimentacoesPeriodo($this->_nrOrg, $nrVinculo, $dtInicio, $dtFim);

        foreach($this->_movimentacao->getItems() as $item){
            if ((int)$item->getNrtipoestrutura() === (int)$tpHierarquiaTomador->getNrtipoestrutrel()) {
                $nrEstruturaSup = $this->_determinaEstruturaSuperior(
                    $hierarquiasTomador, $item->getNrestruturam(), $tpHierarquiaTomador->getIdautohierarq()
                );
                if ($nrEstruturaSup === null) {
                    tk_warning ('Verifique movimentação com estrutura nula para vinculo '.$nrVinculo);
                } else {
                    $this->_estruturaTomador->carregaEstrutura($nrEstruturaSup);
                    $this->_movimentacoesVinculoTomador[$nrEstruturaSup] = $item;
                }

            } else {
                //$this->_estruturaTomador->resetItems();
            }

        }

        return $this->_estruturaTomador->getItems();
    }


    private function _determinaEstruturaSuperior(array $hierarquias, $nrEstrutura, $autoHierarquia){
        // Metodo duplicado  - Contabilizacao. Ir para Hierarquia.
        if ($autoHierarquia === TipohierarqorgEntity::IDAUTOHIERARQ_SIM) {
            $nrEstruturaSup = $nrEstrutura;
        } else {
            $nrEstruturaSup = $this->_hierarquiaOrg->determinaEstruturaSuperior($nrEstrutura, $hierarquias);
        }

        return $nrEstruturaSup;
    }


    /**
     * Enter description here ...
     *
     * @param EstruturamEntity $estrutura Instancia de EstruturamEntity.
     *
     * @return EnderecoEntity
     *
     * @author alessandrobartels - 03/01/2012
     *         alessandrobartels - 17/04/2012 - retirado do SEFIP
     */
    public function determinaEnderecoEstrutura(EstruturamEntity $estrutura){

        // Busca endereco da estrutura.
        $nrParceiro = $estrutura->historico->getNrparcnegocio();

        if ($nrParceiro !== null) {

            $endereco = $this->_enderecoParc->retornaEnderecoParceiroPorTipo(
                $this->_nrOrg, $nrParceiro, self::ENDERECO_PRINCIPAL
            );


            if (!$endereco) {

                // leonardocarvalho 14/08/2014
                throw new \Exception('Conferir dados de endereço da estrutura '.$estrutura->historico->getNrestruturam().'.');

//                $endereco = new EnderecoparcEntity;
//                $endereco->setDsendereco('INDEFINIDO');
//                $endereco->setSgestado('MG'); // UF definido, pois o CAGED solicita um UF válido.
//                $endereco->setNrcependereco('00000000');
//                $endereco->municipio = 'INDEFINIDO';
//                $endereco->bairro = 'INDEFINIDO';
//                $endereco->ddd = '031'; // DDD definido, pois o CAGED solicita um DDD válido.
//                $endereco->telefone = '00000000';
//                $endereco->ramal = '99999999';
//                $endereco->email = 'indefinido@indefinido.com.br';
//                $endereco->complemento = 'INDEFINIDO';
//                return $endereco;

            }

            $municipio = $this->_municipio->retornaMunicipio(
                $endereco->getCdpais(), $endereco->getSgestado(), $endereco->getCdmunicipio()
            );

            if (is_object($municipio) === true) {
                $endereco->municipio = $municipio->getNmmunicipio();
            } else {
                $endereco->municipio = null;
            }

            // Bairro
            $endereco->bairro = $this->_bairro->defineBairro($endereco);

            $endereco->separaDsEndereco();

            // Complemento
            if ($endereco->getDscompleendereco() !== null){
                $endereco->complemento = $endereco->getDscompleendereco();
            } else {
                $endereco->complemento = $endereco->getComplemento();
            }


            $this->_comunicaParc->resetItems();
            $objComunicacoesParc = $this->_comunicaParc->retornaComunicacaoPorParceiro(
                $this->_nrOrg, $estrutura->historico->getNrparcnegocio()
            );

            $endereco->telefone = null;
            $endereco->email = null;
            $endereco->ddd = null;
            $endereco->ramal = null;

            foreach ($objComunicacoesParc as $formaComunicacao){

                /** @var $formaComunicacao ComunicaparcEntity **/

                // Telefone Principal.
                if ($formaComunicacao->getCdformacomu() ===  self::FORMA_COMUNICACAO_TEL_PRINCIPAL) {
                    $endereco->ddd = $formaComunicacao->getCdprefixcomuparc();
                    $endereco->telefone = $formaComunicacao->getCdcomunicaparc();
                    $endereco->ramal = '99999999';
//                    $endereco->ramal = $formaComunicacao->getCdcomplecomuparc();
//                    $endereco->ddd = $this->getDDD($endereco->getSgestado());
//                    $endereco->telefone = '35553600';
//                    $endereco->ramal = '35553600';
                }

                // E-mail.
                if ($formaComunicacao->getCdformacomu() ===  self::FORMA_COMUNICACAO_EMAIL) {
                    $endereco->email = $formaComunicacao->getCdcomunicaparc();
                }

            }

            if($endereco->telefone == null) {
//                $endereco->telefone = '35553600';
                tk_warning('Telefone não parametrizado na estrutura '.$estrutura->historico->getNrestruturam().'.');
            }

            // DDD definido, pois o CAGED solicita um DDD válido.
            if($endereco->ddd == null) {
//                $endereco->ddd = '031';
                tk_warning('DDD não parametrizado na estrutura '.$estrutura->historico->getNrestruturam().'.');
            }
            if($endereco->ramal == null) {
                $endereco->ramal = '99999999';
//                tk_warning('Ramal não parametrizado na estrutura '.$estrutura->historico->getNrestruturam().'.');
            }
            if($endereco->email == null) {
//                $endereco->email = 'alibras@alibras.com.br';
                tk_warning('Email não parametrizado na estrutura '.$estrutura->historico->getNrestruturam().'.');
            }
            if($endereco->getDsendereco() == null) {
//                $endereco->setDsendereco('indefinido');
                tk_warning('Endereco não parametrizado na estrutura '.$estrutura->historico->getNrestruturam().'.');
            }
            if($endereco->bairro == null) {
//                $endereco->bairro = 'indefinido';
                tk_warning('Bairro não parametrizado na estrutura '.$estrutura->historico->getNrestruturam().'.');
            }

            return $endereco;

        } else {
            tk_warning("Parceiro da estrutura: {$estrutura->getNrestruturam()} Inválido");
            return null;
        }
    }


    public function determinaAreaRisco($vinculo, $estrutura){
        // Verifica se o vinculo esta associado a alguma area de risco (AR).
        $resultados = $this->_vinculoAreaRisco->retornaVinculoAreaRisco($this->_nrOrg, $vinculo->getNrvinculom());
        foreach ($resultados as $item) {
            $periodoValido = $this->_verificaPeriodoValidoMes($item->getDtfimvincarearisco());
            if ($periodoValido === true) {
                // Descobre a AR associada ao vinculo
                $areaRisco = $this->_areaRisco->retornaAreaRisco(
                    $this->_nrOrg, $this->_mesCompetencia, $item->getNrareariscom()
                );
            }
        }

        // Se vinculo nao estiver associado a AR verifica a associacao da estrutura com a AR.
        if (is_object($areaRisco) === false) {
            //
            $resultados = $this->_estruturaAreaRisco->retornaEstruturaAreaRisco(
                $this->nrOrg, $estrutura->getNrestruturam()
            );
            foreach ($resultados as $item) {
                $periodoValido = $this->_verificaPeriodoValidoMes($item->getDtfimestrutarearisco());
                if ($periodoValido === true) {
                    // Descobre a AR associada a estrutura
                    $areaRisco = $this->_areaRisco->retornaAreaRisco(
                        $this->_nrOrg, $this->_mesCompetencia, $item->getNrareariscom()
                    );
                }
            }
        }

        $this->_areaRisco = $areaRisco;

        //return $areaRisco;

    }

    public function getDDD($sgestado)
    {
        return $this->_listaDDD[$sgestado];
    }




/*
    private function _carregaEstruturaSuperior($hierarquias, $tpHierarquia, $nrVinculo, $dtInicio, $dtFim){

        $this->_movimentacao->carregaMovimentacoesPeriodo($this->_nrOrg, $nrVinculo, $dtInicio, $dtFim);

        foreach($this->_movimentacao->getItems() as $item){
            if ((int)$item->getNrtipoestrutura() === (int)$tpHierarquia->getNrtipoestrutrel()) {
                // Descobrir a estrutura superior
                $nrEstruturaSup = $this->_determinaEstruturaSuperior($hierarquias, $item->getNrestruturam(), $tpHierarquia->getIdautohierarq());
                //retornar a instancia estrutura
                $this->_estrutura->carregaEstrutura($nrEstruturaSup);
            }
        }
    }

*/
}
